class CribleEratostheneRapide 
{
    public static void main (String[] arguments)
    {
	int i,j,max = Integer.parseInt(arguments[0]);
	int racineDeMax = (int)(Math.sqrt(max)+1);
	boolean[] nombresPremiers = new boolean[max+1];
	
	// Initialisation du tableau
	for (i=2 ; i <= max ; i++)
	    nombresPremiers[i] = true;
	
	// Test pour connatre les nombres premiers
	for (i=2 ; i <= racineDeMax ; i++)
	    if (nombresPremiers[i] == true)
		for (j=2 ; i*j <= max ; j++) 
		    nombresPremiers[i*j] = false;
	
	// Affichage des rsultats
	for (i=2 ; i <= max ; i++)
	    if (nombresPremiers[i] == true) 
		System.out.println(i);
    }
}
