import javax.swing.*;
import java.awt.*;

class PositionnementDesComposants
{
    PositionnementDesComposants(int choix)
    {
	JFrame laFentre = new JFrame("Placement de composants");
	JPanel leConteneurIntermdiaire = new JPanel();
	laFentre.setContentPane(leConteneurIntermdiaire);
	JButton un = new JButton("un"), deux = new JButton("deux"),
	    trois = new JButton("trois"), quatre = new JButton("quatre"), 
	    cinq = new JButton("cinq");
	
	switch (choix) {
	case 0:
	    // choix du gestionnaire de placement par dfaut (FlowLayout dans
	    // le cas de composant-conteneur intermdiaire de type JPanels) :
	    leConteneurIntermdiaire.setLayout(new FlowLayout());
	    // ajout des composants  proprement parler :
	    leConteneurIntermdiaire.add(un);
	    leConteneurIntermdiaire.add(deux);
	    leConteneurIntermdiaire.add(trois);
	    leConteneurIntermdiaire.add(quatre);
	    leConteneurIntermdiaire.add(cinq);
	    break;
	case 1:
	    // choix d'un gestionnaire de placement de type BorderLayout :
	    leConteneurIntermdiaire.setLayout(new BorderLayout());
	    // ajout des composants  proprement parler :
	    leConteneurIntermdiaire.add(un,BorderLayout.NORTH);
	    leConteneurIntermdiaire.add(deux,BorderLayout.WEST);
	    leConteneurIntermdiaire.add(trois,BorderLayout.CENTER);
	    leConteneurIntermdiaire.add(quatre,BorderLayout.EAST);
	    leConteneurIntermdiaire.add(cinq,BorderLayout.SOUTH);
	    break;
	case 2:
	    // choix d'un gestionnaire de placement de type BoxLayout :
	    leConteneurIntermdiaire.
		setLayout(new BoxLayout(leConteneurIntermdiaire,BoxLayout.Y_AXIS));
	    un.setAlignmentX(Component.CENTER_ALIGNMENT);
	    deux.setAlignmentX(Component.LEFT_ALIGNMENT);
	    trois.setAlignmentX(Component.CENTER_ALIGNMENT);
	    quatre.setAlignmentX(Component.RIGHT_ALIGNMENT);
	    cinq.setAlignmentX(Component.CENTER_ALIGNMENT);
	    // ajout des composants  proprement parler :
	    leConteneurIntermdiaire.add(un);
	    leConteneurIntermdiaire.add(deux);
	    leConteneurIntermdiaire.add(trois);
	    leConteneurIntermdiaire.add(quatre);
	    leConteneurIntermdiaire.add(cinq);
	    break;
	case 3:
	    // choix d'un gestionnaire de placement de type GridLayout :
	    leConteneurIntermdiaire.setLayout(new GridLayout(3,2));
	    // ajout des composants  proprement parler :
	    leConteneurIntermdiaire.add(un);
	    leConteneurIntermdiaire.add(deux);
	    leConteneurIntermdiaire.add(trois);
	    leConteneurIntermdiaire.add(quatre);
	    leConteneurIntermdiaire.add(cinq);
	    break;
	}
	// affichage de la fentre :
	laFentre.pack();
        laFentre.setVisible(true);	
    }
    
    public static void main (String[] arguments)
    {
        // on lance l'interface en instanciant la classe courante :
        new PositionnementDesComposants(Integer.parseInt(arguments[0]));
    }
}
