class TriangleDePascal
{
    int[][] tab;
    
    TriangleDePascal(int dimension) {
	tab = new int [dimension][];
	for(int ligne=0 ; ligne<dimension ; ligne++) {
	    // instanciation de la ligne courante :
	    tab[ligne] = new int[ligne+1];
	    // initialisation des lments de la ligne de la ligne courante :
	    tab[ligne][0] = 1;
	    for(int colonne=1 ; colonne<ligne ; colonne++)
		tab[ligne][colonne] = tab[ligne-1][colonne-1] + tab[ligne-1][colonne];
	    tab[ligne][ligne] = 1;
	}
    }
    
    void afficher() {
	for(int ligne=0 ; ligne<tab.length ; ligne++) {
	    // affichage de toute la ligne courante :
	    for(int colonne=0 ; colonne<tab[ligne].length ; colonne++)
		System.out.print(tab[ligne][colonne] + " ");
	    System.out.println();
	}
    }
    
    public static void main (String[] arguments)
    {
	// instanciation d'un Triangle de Pascal sur 7 lignes :
	TriangleDePascal unPetitTriangle = new TriangleDePascal(7);
	// affichage du contenu de ce Triangle :
	unPetitTriangle.afficher();
    }
}
