import java.io.*;

class AccesDirect 
{
    final static int MAX = 100;
    static void critureDirecte(String nomFichier) throws IOException
    {
	// accs en criture (mode "rw") au fichier de nom "nomFichier" :
	RandomAccessFile monFichier = new RandomAccessFile(nomFichier,"rw");
	for (int i=1 ; i<MAX ; i++) {
	    monFichier.writeInt(i);
	    if ((i & 1) == 0)
		monFichier.writeBoolean(true);  // i est un entier pair
	    else
		monFichier.writeBoolean(false); // i est un entier impair
	}
	monFichier.close();
    }
    
    static void lectureDirecte(String nomFichier) throws IOException
    {
	// accs en lecture (mode "r") au fichier de nom "nomFichier" :
	RandomAccessFile monFichier = new RandomAccessFile(nomFichier,"r");
	// accdons au 17ime enregistrement du fichier comportant 100
	// couples entier/parit associe pour dterminer la parit de
	// l'entier 17 :
	monFichier.seek( 16 * (4+1) );
	System.out.println(monFichier.readInt() + " " + monFichier.readBoolean());
	// pour obtenir la parit de l'entier 78,  partir du dbut du
	// fichier, nous devons nous dplacer de 77 * (4+1) octets :
	monFichier.seek( 77 * (4+1) );
	System.out.println(monFichier.readInt() + " " + monFichier.readBoolean());
	monFichier.close();
    }
    
    public static void main (String[] arguments) throws IOException
    {
	critureDirecte("exemple.dat");
	lectureDirecte("exemple.dat");
    }
}
