import java.io.*;

class FluxBinaires
{
    static void critureBinaire(String nomFichier) throws IOException
    {
	double[] valeur = {3.14159,6.55957,2.71828};
	// ouverture du flux de donnes en criture :
	DataOutputStream sortie = new 
	    DataOutputStream(new FileOutputStream(nomFichier));
	for(int i=0 ; i<valeur.length ; i++)
	    sortie.writeDouble(valeur[i]);
	sortie.close();
    }

    static void lectureBinaire(String nomFichier) throws IOException
    {
	// ouverture du flux de donnes en lecture :
	DataInputStream entre = new 
	    DataInputStream(new FileInputStream(nomFichier));
	try {
	    while (true) {
		System.out.println(entre.readDouble());
	    }
	}
	catch (EOFException e) {
	    // l'exception instance de la classe EOFException a t
	    // leve suite  une tentative de lecture sur un fin de
	    // fichier.
	}
	entre.close();
    }
    
    public static void main (String[] arguments) throws IOException
    {
	critureBinaire("exemple.dat");
	lectureBinaire("exemple.dat");
    }
}

