import java.io.*;

class LireEcrireDansUnFichier
{
    // la constante DIM correspond  la taille (constante) des chanes de
    // caractres qui correspondent aux diverses couleurs "vert", "bleu",
    // "gris", "brun" et "noir" que l'on souhaite stocker dans un fichier sur
    // disque :
    final static short DIM = 4;
    
    static void critureDeCaractres(String nomFichier) throws IOException
    {
	// le tableau des couleurs :
	String[] couleurs = {"vert","bleu","gris","brun","noir"};
	// le flux en criture sur disque :
	Writer sortie = new FileWriter(new File(nomFichier));

	for(int i=0 ; i<couleurs.length ; i++)
  	    sortie.write( couleurs[i] );
	sortie.close();
    }
    
    static void lectureDeCaractres(String nomFichier) throws IOException
    {
	// instanciation d'un tableau de "DIM" caractres :
	char[] tableau = new char[DIM];
	// le flux en lecture sur disque :
	Reader entre = new FileReader(new File(nomFichier));
	
	while (entre.read(tableau) != -1) {
	    // affichage des caractres lus sur la sortie standard :
	    System.out.println(tableau);
	}
	entre.close();
    }
    
    public static void main (String[] arguments) throws IOException
    {
	critureDeCaractres("exemple.txt");
	lectureDeCaractres("exemple.txt");
    }
}
