public class Matrice implements InterfaceDeMatrice
{
    // le tableau des valeurs de type flottant en double prcision. Il doit
    // tre dclar public pour que les classes filles puissent en hriter :
    public double [][] valeurs = null;
    /** le constructeur sans argument */
    public Matrice () 
    {
    }
    /** le constructeur  un argument */
    public Matrice (double [][] tableau)
    {
	int nbcol = tableau[0].length;
	for (int i=1 ; i<tableau.length ; i++)
	    if (nbcol != tableau[i].length) {
		System.err.println("Taille de la matrice non constante");
		System.exit(1);
	    }
	this.valeurs = tableau;
    }
    /** le constructeur  deux arguments */
    public Matrice (int nombreDeLignes,int nombreDeColonnes)
    {
        valeurs = new double[nombreDeLignes][nombreDeColonnes];
    }
    /** la mthode d'instance : affichage de la matrice courante */
    public void afficher() 
    {
	for (int i=0 ; i<nombreDeLignes() ; i++)
            {
                for (int j=0 ; j<nombreDeColonnes() ; j++)
                    System.out.print(valeurs[i][j]+"\t"); 
                System.out.println();
            }
    }
    /** mthode d'instance permettant de rcuprer le nombre de colonnes d'une
     *  matrice */
    public int nombreDeColonnes()
    {
	return valeurs[0].length;
    }
    /** mthode d'instance permettant de rcuprer le nombre de lignes d'une
     *  matrice */
    public int nombreDeLignes()
    {
	return valeurs.length;
    }    
    /**
     * la mthode d'instance : produit de matrices 
     * @param Matrice : autre matrice du produit
     * @return Rsultat.valeurs = this.valeurs * M.valeurs
     */
    public Matrice multipliPar(Matrice M)
    {
	Matrice Rsultat = new Matrice (nombreDeLignes(),M.nombreDeColonnes());
	
	if (nombreDeColonnes() == M.nombreDeLignes()) {
	    for (int i=0 ; i < nombreDeLignes() ; i++) {
		for (int j=0 ; j < M.nombreDeColonnes() ; j++) {
		    Rsultat.valeurs[i][j] = 0;
		    for (int k=0 ; k < nombreDeColonnes() ; k++) 
			Rsultat.valeurs[i][j] += valeurs[i][k] * M.valeurs[k][j];
		}
	    }
	}
	else {
	    System.err.println("Ces matrices ne peuvent pas tre multiplies !");
	    System.exit(1);
	}
	return Rsultat;
    }
}
