public class MatriceDiagonale 
    extends MatriceCarree 
    implements InterfaceDeMatriceDiagonale
{
    /** le constructeur sans argument */
    public MatriceDiagonale () 
    {
    }
    public MatriceDiagonale (int taille) 
    {
	super(taille);
    }
    public MatriceDiagonale (double [][] tableau) 
    {
        int taille = tableau.length;
        for (int i=0 ; i<taille ; i++)
	    for (int j=0 ; j<taille ; j++)
		if ((i != j) && (tableau[i][j] != 0)) {
		    System.err.println("La matrice n'est pas diagonale !");
		    System.exit(1);
		}
        this.valeurs = tableau;
    }
    public MatriceDiagonale (int nombreDeLignes,int nombreDeColonnes) 
    {
	super(nombreDeLignes,nombreDeColonnes);
    }
    public Matrice multipliPar(Matrice M) 
    {
        Matrice Rsultat = new Matrice(nombreDeLignes(),M.nombreDeColonnes());

        if (nombreDeColonnes() == M.nombreDeLignes()) {
            for (int i=0 ; i < nombreDeLignes() ; i++) {
                for (int j=0 ; j < M.nombreDeColonnes() ; j++) {
		    // il n'y a ici nul besoin d'imbriquer une troisime
		    // boucle puisque la matrice courante est diagonale :
                    Rsultat.valeurs[i][j] =  valeurs[i][i] * M.valeurs[i][j];
                }
            }
        }
        else {
            System.err.println("Ces matrices ne peuvent pas tre multiplies !");
            System.exit(1);
        }
        return Rsultat;
    }
}
