public class MatriceIdentite
    extends MatriceDiagonale implements InterfaceDeMatriceIdentite
{
    /** le constructeur sans argument */
    public MatriceIdentite () 
    {
    }
    public MatriceIdentite (int taille) 
    {
	super(taille);
    }
    public MatriceIdentite (double [][] tableau) 
    {
        int taille = tableau.length;
        for (int i=0 ; i<taille ; i++)
	    for (int j=0 ; j<taille ; j++)
		if (((i != j) && (tableau[i][j] != 0)) || ((i==j) && (tableau[i][j] != 1))) {
		    System.err.println("La matrice n'est pas la matrice identit !");
		    System.exit(1);
		}
        this.valeurs = tableau;
    }
    public MatriceIdentite (int nombreDeLignes,int nombreDeColonnes) 
    {
	super(nombreDeLignes,nombreDeColonnes);
    }
    public double trace() 
    {
	// dans le cas d'une matrice identit, la trace quivaut  la
	// dimension puisque tous les lments diagonaux valent 1 :
	return dimension();
    }
    
    public Matrice multipliPar (Matrice M)
    {
        if (dimension() != M.nombreDeLignes()) {
            System.err.println("Ces matrices ne peuvent pas tre multiplies !");
            System.exit(1);
        }
	return M;
    }
}
