import java.math.*;

final class PiEnBigDecimal
{
    static final int prcision = 4000;
    static final int arrondi = BigDecimal.ROUND_DOWN;
    static final BigDecimal moinsDeux = new BigDecimal(-2).setScale(prcision);
    static final BigDecimal moinsUn = new BigDecimal(-1).setScale(prcision);
    static final BigDecimal zro = new BigDecimal(0).setScale(prcision);
    static final BigDecimal un = new BigDecimal(1).setScale(prcision);
    static final BigDecimal quatre = new BigDecimal(4).setScale(prcision);
    static final BigDecimal cinq = new BigDecimal(5).setScale(prcision);
    static final BigDecimal six = new BigDecimal(6).setScale(prcision);
    static final BigDecimal huit = new BigDecimal(8).setScale(prcision);
    static final BigDecimal seize = new BigDecimal(16).setScale(prcision);
    private static BigDecimal inversePuissance16=un, huitFoisI=zro;

    public static BigDecimal calculDUneHexadcimale(int i)
    {
	BigDecimal rsultat = quatre.divide(huitFoisI.add(un),arrondi).
	    add(moinsDeux.divide(huitFoisI.add(quatre),arrondi)).
	    add(moinsUn.divide(huitFoisI.add(cinq),arrondi)).
	    add(moinsUn.divide(huitFoisI.add(six),arrondi)).
	    multiply(inversePuissance16);
	inversePuissance16 = inversePuissance16.divide(seize,arrondi);
	huitFoisI = huitFoisI.add(huit);
	return rsultat;
    }

    public static void afficher(BigDecimal pi)
    {
	StringBuffer chane = new StringBuffer(pi.toString());
	chane.insert(2,'\n');
 	for (int i=13 ; i<chane.length() ; i+=11)
	    chane.insert(i , ((i-57)%55 != 0) ? ' ' : '\n');
	System.out.println(chane.substring(0,2202));
    }

    public static void main (String[] arguments)
    {
	BigDecimal pi=zro;
	for (int i=0 ; i<Integer.parseInt(arguments[0]) ; i++)
	     pi = pi.add(calculDUneHexadcimale(i));
	afficher(pi);
    }
}
