import java.net.*;
import java.io.*;

class ClientReseau
{
    public static void main (String[] arguments) 
    {
	Socket maSocket = null;         // la socket
	int port = 0;                   // le port  ouvrir
	BufferedReader entre = null;   // le flux correspondant  cette socket
	String ligne;                  // les lignes lues dans le flux
	
	try {
	    port = Integer.parseInt(arguments[1]);
	    maSocket = new Socket(arguments[0],port);
	}
	catch (ArrayIndexOutOfBoundsException uneException) {
	    System.err.println
		("Usage : java ClientReseau <nom de machine cible> <numro de port cible>");
	    System.exit(1);
	}
	catch (NumberFormatException uneException) {
	    System.err.println("Le port cible " + arguments[1] + " n'est pas un entier !");
	    System.exit(2);
	}
	catch (UnknownHostException uneException) {
	    System.err.println("La machine " + arguments[0] + " est inaccessible !");
	    System.exit(3);
	}
	catch (ConnectException uneException) {
	    System.err.println("Connexion au port " + port + " refuse !");
	    System.exit(4);
	}
	catch (IllegalArgumentException uneException) {
	    System.err.println(port + " n'est pas un port valide !");
	    System.exit(5);
	}
	catch (SocketException uneException) {
	    System.err.println("Erreur  l'tablissement de la socket !");
	    System.exit(6);
	}
	catch (IOException uneException) {
	    System.err.println("Erreur de lecture du flux d'entre.");
	    System.exit(7);
	}

	try {
	    entre = new BufferedReader(new InputStreamReader(maSocket.getInputStream()));
	    while ((ligne = entre.readLine()) != null)
		System.out.println(ligne);
	    entre.close();
	    maSocket.close();
	}
	catch (IOException uneException) {
	    System.err.println("Erreur de lecture du flux d'entre.");
	    System.exit(8);
	}
    }
}
