import java.net.*;
import java.io.*;

class ScannerDePortsTCP
{
    private String adresse;
    private int portMax;

    ScannerDePortsTCP(String adresse,int portMax)
    {
	this.adresse = adresse;
	this.portMax = portMax;
    }

    public void lancer()
    {
	Socket maSocket;
	
	for(int port=1 ; port <= portMax ; port++) {
	    try {
		maSocket = new Socket(adresse,port);
		System.out.println(port + "/tcp open sur " + adresse);
	    }
	    catch (UnknownHostException uneException) {
		System.err.println("La machine " + adresse + " est inaccessible !");
		System.exit(1);
	    }
	    catch (ConnectException uneException) {
	    }
	    catch (IOException uneException) {
		System.err.println("Erreur de lecture du flux d'entre.");
		System.exit(2);		
	    }
	    catch (IllegalArgumentException uneException) {
		System.err.println("Vous tes sorti de l'intervalle 1, ..., 65535.");
		System.exit(3);		
	    }
	}
    }

    public static void main (String[] arguments) throws InterruptedException
    {
	String cible = arguments[0];
	int portMax = Integer.parseInt(arguments[1]);

	long dateDbut = System.currentTimeMillis(); // mesure du temps

	ScannerDePortsTCP monScan = new ScannerDePortsTCP(cible,portMax);
	monScan.lancer();

	long dateFin = System.currentTimeMillis(); // mesure du temps
	System.err.println("Temps d'excution = " + (dateFin-dateDbut) + " ms");
    }
}
