class AccesConcurrent1
{
    int taille = 0;
    
    AccesConcurrent1()
    {
	Thread a,b;
	(a = new Thread(new Fournisseur())).start();
	(b = new Thread(new Fournisseur())).start();
	// on attend la fin des threads a et b pour procder  l'affichage de
	// la valeur de "taille" dans le thread principal :
	try {
	    a.join();
	    b.join();
	} catch (InterruptedException uneException) {}
	System.out.println("Taille totale : " + taille);
    }

    void incrmenter(int unEntier)
    {
	int tmp = taille;
	// l'instruction yield qui suit rend la main au scheduler : c'est ce
	// qui va permettre  la valeur de la variable d'instance "taille" de
	// changer entre temps dans l'autre thread...
	Thread.currentThread().yield();
	taille = tmp+unEntier;
    }    

    class Fournisseur implements Runnable
    {
	public void run() 
	{
	    incrmenter(10);
	}
    }
    
    public static void main (String[] arguments)
    {
	new AccesConcurrent1();
    }
}

