import java.sql.*;

public class LocationDeVoiliers
{
    public static void main (String[] arguments)
    {
	String nomClient,prenomClient,telephone;
        try {
	    // chargement dynamique ( l'excution et non  la compilation) du
	    // pilote MySQL :
	    Class.forName("org.gjt.mm.mysql.Driver").newInstance();
	    // tablissement de la connexion avec le SGBDR :
            Connection connexion = 
		DriverManager.getConnection("jdbc:mysql://127.0.0.1:3306/ESSAI","leduc","123");
	    // tablissement et soumission de la requte statique :
	    Statement dclaration = connexion.createStatement();
            ResultSet rsultats = dclaration.executeQuery(
                 "SELECT clients.nomClient,clients.prenomClient,clients.telephone " +
		 "FROM clients,bateaux,reservations " +
		 "WHERE bateaux.nomBateau LIKE 'Jeanneau Sun Fast 40' " +
		 "AND bateaux.identifiantBateau = reservations.identifiantBateau " +
		 "AND clients.identifiantClient = reservations.identifiantClient " +
		 "GROUP BY clients.identifiantClient");
	    // lecture des rsultats :
            while (rsultats.next())
                {
                    nomClient = rsultats.getString("nomClient");
                    prenomClient = rsultats.getString("prenomClient");
                    telephone = rsultats.getString("telephone");
                    System.out.println(nomClient.toUpperCase() + " " + 
				       prenomClient + " : " + telephone);
                }
            rsultats.close();
            dclaration.close();
            connexion.close();
        }
        catch (SQLException e) {
        }
        catch (java.lang.Exception e) {
        }
    }
}
