import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;

class CribleEratosthene 
{
    Set leCrible;
    
    CribleEratosthene(int n)
    {
	leCrible = new TreeSet();
	for(int i=2 ; i<n ; i++)
	    leCrible.add(new Integer(i));
    }
    
    void afficher()
    {
	Iterator i = leCrible.iterator();
	while (i.hasNext())
	    System.out.println( i.next() );
    }
    
    void liminerLesMultiplesDe(int n)
    {
	Set tmp = new TreeSet();
	Integer variant;
	
	Iterator i = leCrible.iterator();
	while (i.hasNext()) {
	    variant = (Integer) i.next();
	    if ((variant.intValue() % n == 0) && (variant.intValue() > n))
		tmp.add(variant);
	}
	leCrible.removeAll(tmp);
    }
    
    void liminerLesNonPremiers()
    {
	for (int i=0 ; i < leCrible.size() ; i++) {
	    Object[] tmp = leCrible.toArray();
	    liminerLesMultiplesDe(((Integer) tmp[i]).intValue());
	}
    }
    
    public static void main (String[] arguments)
    {
	CribleEratosthene ce = new CribleEratosthene(Integer.parseInt(arguments[0]));
	ce.liminerLesNonPremiers();
	ce.afficher();
    }
}
