import java.util.Enumeration;
import java.util.Vector;

class SiteBoursier
{
    Vector tableauDesValeurs;

    SiteBoursier()
    {
	tableauDesValeurs = new Vector();
    }

    void introductionDeValeur(CotationEnBourse uneValeur)
    {
	tableauDesValeurs.addElement(uneValeur);
	System.out.println("=> Vous avez entr la valeur numro : " + nombreDeValeurs());
    }

    void suppressionDeValeur(CotationEnBourse uneValeur)
    {
	if (tableauDesValeurs.remove(uneValeur)) {
	    System.out.println("Vous venez de supprimer la valeur :");
	    uneValeur.afficher();
	    System.out.println("=> Il vous reste " + nombreDeValeurs() + " valeurs !");
	}
	else System.err.println("Cette valeur n'existe pas !");
    }

    void suppressionDeValeur(int index)
    {
	if (index < nombreDeValeurs()) {
	    CotationEnBourse supprime = (CotationEnBourse) tableauDesValeurs.remove(index);
	    if (supprime != null) {
		System.out.println("Vous venez de supprimer la valeur :");
		supprime.afficher();
		System.out.println("=> Il vous reste " + nombreDeValeurs() + " valeurs !");
	    }
	    else System.err.println("Cette valeur n'existe pas !");
	}
	else System.err.println("Cette valeur n'existe pas !");
    }
    
    int nombreDeValeurs()
    {
	return tableauDesValeurs.size();
    }

    void affichageDeValeur(CotationEnBourse uneValeur)
    {
	affichageDeValeur(tableauDesValeurs.lastIndexOf(uneValeur));
    }

    void affichageDeValeur(int index)
    {
	((CotationEnBourse) tableauDesValeurs.get(index)).afficher();
    }
    
    void listingDesValeurs()
    {
	System.out.println("Vous avez " + nombreDeValeurs() + " valeurs.");
	// utilisation d'une Enumeration :
	Enumeration lesValeurs = tableauDesValeurs.elements();
	while (lesValeurs.hasMoreElements())
	    ((CotationEnBourse) lesValeurs.nextElement()).afficher();
    }
    
    public static void main (String[] arguments)
    {
	// commenons par instancier la place boursire que nous allons dvelopper :
	SiteBoursier placeDeParis = new SiteBoursier();
	// dfinissons ensuite 4 valeurs :
	CotationEnBourse valeurA = new CotationEnBourse("Socit A et Cnie",100f);
	CotationEnBourse valeurB = new CotationEnBourse("valeur B et Cnie",440f);
	CotationEnBourse valeurC = new CotationEnBourse("Socit C et Cnie",500f);
	CotationEnBourse valeurD = new CotationEnBourse("Socit D et Cnie",120f);
	// introduisons ces valeurs sur la place boursire instancie prcdemment :
	placeDeParis.introductionDeValeur(valeurA);
	placeDeParis.introductionDeValeur(valeurB);
	placeDeParis.introductionDeValeur(valeurC);
	placeDeParis.introductionDeValeur(valeurD);
	// affichons l'ensemble des valeurs ctes sur notre place boursire :
	placeDeParis.listingDesValeurs();
	// supprimons la 3ime valeur et la valeur 'valeurB' :
	placeDeParis.suppressionDeValeur(3);
	placeDeParis.suppressionDeValeur(valeurB);
	// supprimons les  nouveau mmem si elles ne sont plus ctes a priori :
	placeDeParis.suppressionDeValeur(3);
	placeDeParis.suppressionDeValeur(valeurB);
	// affichons l'ensemble des valeurs encore en cotation sur notre place boursire :
	placeDeParis.listingDesValeurs();
    }
}
