import java.io.*;

class ManipulationClasseFile
{
    static void tests(File f) throws IOException
    {
	String nomFichier = f.getCanonicalPath();
	
	if (f.exists()) {
	    System.out.println(nomFichier + " existe bien");
	    if (f.canRead())
		System.out.println("Il est accessible en lecture");
	    if (f.canWrite())
		System.out.println("Il est accessible en criture");
	    if (f.isFile()) {
		System.out.print("C'est un fichier");
		System.out.println(" de " + f.length() + " octets");
	    }
	    else if (f.isDirectory()) {
		System.out.println("C'est un rpertoire qui contient");
		String[] contenuRpertoire = f.list();
		for (int i=0 ; i<contenuRpertoire.length ; i++)
		    System.out.println("\t" + contenuRpertoire[i]);
	    }
	}
    }
    
    public static void main (String[] arguments) throws IOException
    {
	for (int i=0 ; i<arguments.length ; i++)
	    tests(new File(arguments[i]));
    }
}

