public class MatriceCarree 
    extends Matrice implements InterfaceDeMatriceCarree
{
    /** le constructeur sans argument */
    public MatriceCarree () 
    {
    }
    // apparition d'un nouveau constructeur :
    public MatriceCarree (int taille) 
    {
	super(taille,taille);
    }
    public MatriceCarree (double [][] tableau) 
    {
        int taille = tableau.length;
        for (int i=0 ; i<taille ; i++)
            if (taille != tableau[i].length) {
                System.err.println("La matrice n'est pas carre !");
                System.exit(1);
            }
        this.valeurs = tableau;
    }
    public MatriceCarree (int nombreDeLignes,int nombreDeColonnes) 
    {
	if (nombreDeLignes == nombreDeColonnes)
	    valeurs = new double[nombreDeLignes][nombreDeColonnes];
	else {
	    System.err.println("La matrice n'est pas carre !");
	    System.exit(1);
	}
    }
    public int dimension()  
    {
	return valeurs.length;
    }
    public int nombreDeColonnes()
    {
        return dimension();
    }
    public int nombreDeLignes()
    {
        return dimension();
    }    
    public double trace() 
    {
	// nous pouvons ici en profiter pour dfinir une nouvelle
	// fonctionnalit propre aux matrices carres : le calcul de la somme
	// des lments diagonaux.
	double somme = 0;
	for (int i=0 ; i<dimension() ; i++)
	    somme += valeurs[i][i];
	return somme;
    }
}
