public class MatriceTriangulaireInferieure 
    extends MatriceCarree 
    implements InterfaceDeMatriceTriangulaireInferieure
{
    /** le constructeur sans argument */
    public MatriceTriangulaireInferieure () 
    {
    }
    public MatriceTriangulaireInferieure (int taille) 
    {
	super(taille);
    }
    public MatriceTriangulaireInferieure (double [][] tableau) 
    {
        int taille = tableau.length;
        for (int i=0 ; i<taille ; i++)
	    for (int j=i ; j<taille ; j++)
		if (tableau[i][j] != 0) {
		    System.err.println("La matrice n'est pas triangulaire infrieure !");
		    System.exit(1);
		}
        this.valeurs = tableau;
    }
    public MatriceTriangulaireInferieure (int nombreDeLignes,int nombreDeColonnes) 
    {
	super(nombreDeLignes,nombreDeColonnes);
    }
    public Matrice multipliPar(Matrice M) 
    {
        Matrice Rsultat = new Matrice(nombreDeLignes(),M.nombreDeColonnes());

        if (nombreDeColonnes() == M.nombreDeLignes()) {
            for (int i=0 ; i < nombreDeLignes() ; i++) {
                for (int j=0 ; j < M.nombreDeColonnes() ; j++) {
                    Rsultat.valeurs[i][j] = 0;
		    // k n'a, dans le cas des matrices triangulaires
		    // infrieures, pas besoin d'aller jusqu' l'indice
		    // nombreDeColonnes() :
                    for (int k=0 ; k < i ; k++) 
                        Rsultat.valeurs[i][j] += valeurs[i][k] * M.valeurs[k][j];
                }
            }
        }
        else {
            System.err.println("Ces matrices ne peuvent pas tre multiplies !");
            System.exit(1);
        }
        return Rsultat;
    }
}
