public class MatriceTriangulaireSuperieure 
    extends MatriceCarree 
    implements InterfaceDeMatriceTriangulaireSuperieure
{
    public MatriceTriangulaireSuperieure () 
    {
    }
    public MatriceTriangulaireSuperieure (int taille) 
    {
	super(taille);
    }
    public MatriceTriangulaireSuperieure (double [][] tableau) 
    {
        int taille = tableau.length;
        for (int i=0 ; i<taille ; i++)
	    for (int j=0 ; j<i ; j++)
		if (tableau[i][j] != 0) {
		    System.err.println("La matrice n'est pas triangulaire suprieure !");
		    System.exit(1);
		}
        this.valeurs = tableau;
    }
    public MatriceTriangulaireSuperieure (int nombreDeLignes,int nombreDeColonnes) 
    {
	super(nombreDeLignes,nombreDeColonnes);
    }
    public Matrice multipliPar(Matrice M) 
    {
        Matrice Rsultat = new Matrice(nombreDeLignes(),M.nombreDeColonnes());

        if (nombreDeColonnes() == M.nombreDeLignes()) {
            for (int i=0 ; i < nombreDeLignes() ; i++) {
                for (int j=0 ; j < M.nombreDeColonnes() ; j++) {
                    Rsultat.valeurs[i][j] = 0;
		    // k n'a, dans le cas des matrices triangulaires
		    // suprieures, pas besoin de partir de l'indice 0 :
                    for (int k=i ; k < nombreDeColonnes() ; k++) 
                        Rsultat.valeurs[i][j] += valeurs[i][k] * M.valeurs[k][j];
                }
            }
        }
        else {
            System.err.println("Ces matrices ne peuvent pas tre multiplies !");
            System.exit(1);
        }
        return Rsultat;
    }
}

