import java.net.*;
import java.io.*;
import java.util.*;

class ClientPop3 extends ClientAbstrait
{    
    private final static String UTILISATEUR = new String("leduc");
    private final static String MOT_DE_PASSE = new String("");
    
    ClientPop3(String adresseServeurPop3,int portServicePop3)
    {
        super(adresseServeurPop3,portServicePop3);
    }
    
    void traitement()
    {
        String ligne;
        int numroDeMessage = 1;
        boolean continuer = true;
	
        try {
            // phase d'authentification :
            sortie.println("USER " + UTILISATEUR);
            sortie.println("PASS " + MOT_DE_PASSE);
            // phase de transaction :
            while (continuer) {
                // envoi de la commande de rappatriement du message de numro
                // "numroDeMessage" :
                sortie.println("TOP " + numroDeMessage + " 0");
                // traitement de la rponse en provenance du serveur POP3 :
                if (entre.readLine().startsWith("-ERR"))
                    // le message "numroDeMessage" ne peut pas tre
                    // rappatri, on sort donc de la boucle :
                    continuer = false;
                else {
                    // sinon, on affiche sur la sortie standard les lignes qui
                    // nous intressent :
                    System.out.println("---\nEn-tte du message numro " + numroDeMessage);
                    while (((ligne = entre.readLine()) != null) && ! ligne.equals(".")) {
                        if (ligne.startsWith("Date:") || ligne.startsWith("From:") || 
                            ligne.startsWith("Subject:") || ligne.startsWith("To:"))
                            System.out.println("\t" + ligne);
                    }
                    numroDeMessage++;
                }
            }
            sortie.println("QUIT");         
        }
        catch (IOException uneException){
        }
    }
    
    public static void main (String[] arguments)
    {
        ClientPop3 lesEnTtes = new ClientPop3(arguments[0],110);
        lesEnTtes.traitement();
        lesEnTtes.fermeture();
    }
}
