import java.net.*;
import java.io.*;

class ServeurDeFichier
{
    private ServerSocket leServeur;
    
    ServeurDeFichier(int port) 
	throws IOException,BindException,IllegalArgumentException
    {
	// instanciation du ServerSocket li au port de numro "port" :
	leServeur = new ServerSocket(port);
    }
    
    void lancer() throws IOException
    {

	System.out.println("Le serveur attend des connexions clientes...");
	while (true) 
	    // toute nouvelle socket de service, instancie par appel  la
	    // mthode accept sur le ServerSocket courant, est gre dans un
	    // nouveau thread dit "thread de service" :
	    new Thread(new ServeurDeFichierAuxiliaire(leServeur.accept())).start();
    }
    
    public static void main (String[] arguments) 
	throws IOException,NumberFormatException,ArrayIndexOutOfBoundsException,
	BindException,IllegalArgumentException
    {
	new ServeurDeFichier(Integer.parseInt(arguments[0])).lancer();
    }
}
