import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.text.DateFormat;

class Horloge
{
    // dfinition d'une classe interne qui n'a de raison d'tre qu'au
    // sein de la sur-classe Horloge :
    class HorlogeInterne extends JPanel implements Runnable
    {
	private Thread threadDeMiseAJour = null;
	private Date dateCourante = null;
	private Font fonteHeure = new Font("Helvetica",Font.BOLD,40);
	private Font fonteJour = new Font("Helvetica",Font.PLAIN,12);
	private DateFormat formatHeure = null;
	private DateFormat formatJour = null;
	
	HorlogeInterne(Locale choixDeLaLocale)
	{
	    // On redimensionne le composant courant avant de fixer
	    // les formats d'affichage de la date et de
	    // l'heure. Enfin, on lance le thread de rafrachissement
	    // de l'horloge :
	    setPreferredSize(new Dimension(280,80));
	    formatHeure 
		= DateFormat.getTimeInstance(DateFormat.MEDIUM,choixDeLaLocale);
	    formatJour
		= DateFormat.getDateInstance(DateFormat.LONG,choixDeLaLocale);
	    threadDeMiseAJour = new Thread(this);
	    threadDeMiseAJour.start();
	}
	
	public void paintComponent(Graphics g) {
	    super.paintComponent(g);
	    // affichage de l'heure et de la date courante
	    // respectivement dans des fontes de grosse et petite
	    // tailles :
	    dateCourante = Calendar.getInstance().getTime();
	    g.setFont(fonteHeure);
	    g.drawString(formatHeure.format(dateCourante),40,50);
	    g.setFont(fonteJour);
	    g.drawString(formatJour.format(dateCourante),170,74);
	}    
	
	public void run()
	{
	    // boucle infinie :
	    while (true) {
		// mise  jour du composant graphique (repaint lance
		// paintComponent) :
		repaint();
		try {
		    // le thread "sommeille" pendant 1 seconde avant
		    // de boucler :
		    threadDeMiseAJour.sleep(1000);
		} catch (InterruptedException uneException) {}
	    }    
	}
    }
    
    Horloge(Locale choixDeLaLocale) 
    {
	// on commence par instancier la fentre qui correspond 
	// l'horloge, puis on dfinit son comportement  la fermeture
	// de la fentre :
	JFrame laFentre = new JFrame("Mon horloge...");
	laFentre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	// on insre ensuite le composant permettant l'affichage de
	// l'horloge dans la fentre :
	laFentre.getContentPane().add(new HorlogeInterne(choixDeLaLocale));
        // on procde enfin  l'affichage de l'ensemble :
        laFentre.pack();
        laFentre.setVisible(true);
    }
    
    public static void main (String[] arguments)
    {
	new Horloge(Locale.FRANCE);
	new Horloge(Locale.GERMAN);
    }
}
